﻿using BTerrariaMod.Sugar;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;

namespace BTerrariaMod.Tests
{
    
    
    /// <summary>
    ///This is a test class for EnumerableExtensionsTest and is intended
    ///to contain all EnumerableExtensionsTest Unit Tests
    ///</summary>
    [TestClass()]
    public class EnumerableExtensionsTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


       

        [TestMethod()]
        public void In_Contains_ReturnsTrue()
        {
            var item = "test";
            var items = new[] { item, "test2" };
            var expected = true;
            var actual=item.In(items);
            Assert.AreEqual(expected, actual);

        }
        [TestMethod()]
        public void In_NotIn_ReturnsFalse()
        {
            var item = "test";
            var items = new[] {  "test2" };
            var expected = false;
            var actual = item.In(items);
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void JoinIndex_ReplicatesACounter()
        {
            var test = new[] {"test", "test2","test3","test4"};

            var counter = 0;
            foreach(var item in test.JoinIndex())
            {
                Assert.AreEqual(counter, item.Item1);
                counter++;
            }
            
        }
    }
}
