﻿// ------------------------------------------------------------------------------
// <copyright file="Packet.cs" company="MyCompany.com">
//  Copyright © MyCompany.com. All rights reserved.
// </copyright>
// <author>Me</author>
// ------------------------------------------------------------------------------

namespace Terraria_Server
{
    /// <summary>
    /// Defines packet types
    /// </summary>
    public enum Packet : int
    {
        /// <summary/>
        CONNECTION_REQUEST = 1,

        /// <summary/>
        DISCONNECT = 2,

        /// <summary/>
        CONNECTION_RESPONSE = 3,

        /// <summary/>
        PLAYER_DATA = 4,

        /// <summary/>
        INVENTORY_DATA = 5,

        /// <summary/>
        WORLD_REQUEST = 6,

        /// <summary/>
        WORLD_DATA = 7,

        /// <summary/>
        REQUEST_TILE_BLOCK = 8,

        /// <summary/>
        SEND_TILE_LOADING = 9,

        /// <summary/>
        SEND_TILE_ROW = 10,

        /// <summary/>
        SEND_TILE_CONFIRM = 11,

        /// <summary/>
        RECEIVING_PLAYER_JOINED = 12,

        /// <summary/>
        PLAYER_STATE_UPDATE = 13,

        /// <summary/>
        SYNCH_BEGIN = 14,

        /// <summary/>
        UPDATE_PLAYERS = 15,

        /// <summary/>
        PLAYER_HEALTH_UPDATE = 16,

        /// <summary/>
        TILE_BREAK = 17,

        /// <summary/>
        TIME_SUN_MOON_UPDATE = 18,

        /// <summary/>
        DOOR_UPDATE = 19,

        /// <summary/>
        TILE_SQUARE = 20,

        /// <summary/>
        ITEM_INFO = 21,

        /// <summary/>
        ITEM_OWNER_INFO = 22,

        /// <summary/>
        NPC_INFO = 23,

        /// <summary/>
        STRIKE_NPC = 24,

        /// <summary/>
        PLAYER_CHAT = 25,

        /// <summary/>
        STRIKE_PLAYER = 26,

        /// <summary/>
        PROJECTILE = 27,

        /// <summary/>
        DAMAGE_NPC = 28,

        /// <summary/>
        KILL_PROJECTILE = 29,

        /// <summary/>
        PLAYER_PVP_CHANGE = 30,

        /// <summary/>
        OPEN_CHEST = 31,

        /// <summary/>
        CHEST_ITEM = 32,

        /// <summary/>
        PLAYER_CHEST_UPDATE = 33,

        /// <summary/>
        KILL_TILE = 34,

        /// <summary/>
        HEAL_PLAYER = 35,

        /// <summary/>
        ENTER_ZONE = 36,

        /// <summary/>
        PASSWORD_REQUEST = 37,

        /// <summary/>
        PASSWORD_RESPONSE = 38,

        /// <summary/>
        ITEM_OWNER_UPDATE = 39,

        /// <summary/>
        NPC_TALK = 40,

        /// <summary/>
        PLAYER_BALLSWING = 41,

        /// <summary/>
        PLAYER_MANA_UPDATE = 42,

        /// <summary/>
        PLAYER_USE_MANA_UPDATE = 43,

        /// <summary/>
        KILL_PLAYER_PVP = 44,

        /// <summary/>
        PLAYER_JOIN_PARTY = 45,

        /// <summary/>
        READ_SIGN = 46,

        /// <summary/>
        WRITE_SIGN = 47,

        /// <summary/>
        FLOW_LIQUID = 48,

        /// <summary/>
        SEND_SPAWN = 49,

        /// <summary/>
        PLAYER_BUFFS = 50,

        /// <summary/>
        SUMMON_SKELETRON = 51,

        #region Added in 1.0.6

        /// <summary/>
        CHEST_UNLOCK = 52,

        /// <summary/>
        NPC_ADD_BUFF = 53,

        /// <summary/>
        NPC_BUFFS = 54,

        /// <summary/>
        PLAYER_ADD_BUFF = 55,

        #endregion

        #region Added in 1.1
        
        /// <summary/>
        NPC_NAME = 56,

        /// <summary/>
        WORLD_BALANCE = 57,

        /// <summary/>
        PLAY_HARP = 58,

        /// <summary/>
        HIT_SWITCH = 59,

        /// <summary/>
        NPC_HOME = 60

        // //custom
        // TILE_ROW_COMPRESSED = 240,
        // // TILE_SQUARE_COMPRESSED = 241,

        // //TDCM
        // CLIENT_MOD_SPAWN_NPC = 251,
        // CLIENT_MOD_QUESTG_INFO = 252,
        // //Essentials has 253
        // CLIENT_MOD = 254,
        #endregion
    }
}